const {WebGLRenderer, CanvasTexture, SpriteMaterial, Sprite, Texture } = THREE;
import { getData } from './getData';


export function spriteCanvas(zone, lol) {
 	var canvas = document.createElement('canvas');
  let context = canvas.getContext("2d")
	var width = canvas.width
  var height = canvas.height
  var radius = Math.min(width, height) / 2;

  var colors = ["#de4e4e", "#e46e48", "#e68d49", "#e5a953" , "#e1c467", "#b7ba63", "#91ad65", "#709f68", "#538f6a"];

	var arc = d3.arc()
  	.outerRadius(radius - 15)
    .innerRadius(radius - 40)
      //.padRadius(0.0200)
    .context(context);

  var pie = d3.pie()
    .sort(null)
    .padAngle(0.02)
    .value(function(data) { return data.char; });
    context.translate(width / 2, height / 2);
		
	const run = async () => {
    let data = await getData(lol, zone)
      
   	//data.char = +data.char; 
    
    var arcs = pie(data);
    arcs.forEach(function(data, i) {
    	context.beginPath();
      arc(data);
      context.fillStyle = colors[i];
      context.fill();
    });

    context.beginPath();
    arcs.forEach(arc);
    context.strokeStyle = '#fff';
    context.stroke();
    context.textAlign = "center";
    context.textBaseline = "middle";
    context.fillStyle = "#000";
    context.lineWidth = 2;
    context.stroke();   
    };
  
  	run();
  	return canvas
}

export function spriteTexture(zone, lol) {
 		let texture = new Texture(spriteCanvas(zone, lol));
  	  texture.needsUpdate = true;
  	texture.minFilter = THREE.LinearFilter; // <-- Remove “Texture has been resized” console logs in three.js
  	return texture;
}

export function PieSprite(scene, texture, radius, x, y, z) {
  	let material = new SpriteMaterial({ map: texture})
  	let sprite = new Sprite( material);
    sprite.scale.set(2*radius, radius, 1);
  	sprite.position.set(x, y+(radius/2), z)
  	scene.add(sprite);
}

//export function PieSprite (scene, txtr, radius, x, y, z) {
//    let material = new SpriteMaterial({ map: txtr});
//    let sprite = new Sprite(material);
//  console.log(sprite)
 //   sprite.scale.set(2*radius, radius, 1);
 // 	sprite.position.set(x, y+(radius/2), z)
  //	scene.add(sprite);